package org.apache.stratum.resources;

/**
 * This class is responsible for managing {@link
 * org.apache.stratum.resources.Resource} objects -- use it whenever
 * you need a handle one (rather than instantiating one directly).
 *
 * @author <a href="mailto:jvanzyl@apache.org">Jason van Zyl</a>
 * @author <a href="mailto:dlr@finemaltcoding.com">Daniel Rall</a>
 */
public interface ResourceManager
{
    /**
     * Interface for acquiring handles to various resources.
     *
     * @param resourceName The name of the resource to retrieve.
     * @param encoding The encoding to use.
     * @return The resource (or possibly <code>null</code> if not
     * found).
     */
    Resource getResource(String resourceName, String encoding);
}
